/*
 * JIS X 0208-1990ƂĕsȕEAKȑ̕ɒuvO
 *
 * To compile:
 *	OS/2:	gcc -funsigned-char -O2 -Wall -Zomf -Zcrtdll sjisf.c
 *	DOS:	bcc -K -O2 -a -d -1 -ms sjisf.c
 */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define range(x,a,b)	((x)>=(a)&&(x)<=(b))

static const char*PGM_NAME="Shift_JIS validation filter - Version 0.00\n" \
			   "Copyright (c) 2000, Altair "		  \
			   "(NBG01720@nifty.ne.jp)\n";
static const char*bad="";
int html=0,replace=0,z2h=0,input=0;

static int to_ascii(int x,int y)
{
    int c;

    switch(x){
	case 0x81:
	    switch(y){
		case 0x40: c=' '; break;   case 0x46: c=':';  break;
		case 0x48: c='?'; break;   case 0x47: c=';';  break;
		case 0x4F: c='^'; break;   case 0x49: c='!';  break;
		case 0x51: c='_'; break;   case 0x50: c='~';  break;
		case 0x62: c='|'; break;   case 0x5E: c='/';  break;
		case 0x67:		   case 0x66: c='\''; break;
		case 0x69: c='('; break;   case 0x68: c='"';  break;
		case 0x6D: c='['; break;   case 0x6A: c=')';  break;
		case 0x6F: c='{'; break;   case 0x6E: c=']';  break;
		case 0x7B: c='+'; break;   case 0x70: c='}';  break;
		case 0x81: c='='; break;   case 0x7C: c='-';  break;
		case 0x90: c='$'; break;   case 0x8F: c='\\'; break;
		case 0x94: c='#'; break;   case 0x93: c='%';  break;
		case 0x96: c='*'; break;   case 0x97: c='@';  break;

		case 0x43: fputs(", ",stdout); return 1;
		case 0x44: fputs(". ",stdout); return 1;

		case 0x83: fputs(html?"&lt;":"<", stdout); return 1;
		case 0x84: fputs(html?"&gt;":">", stdout); return 1;
		case 0x95: fputs(html?"&amp;":"&",stdout); return 1;

		default:   return 0;
	    }
	    break;

	case 0x82:
	    if(y>=0x81){
		if(y<=0x9A){
		    c=y-0x81+'a';
		    break;
		}
	    }else if(y>=0x60){
		if(y<=0x79){
		    c=y-0x60+'A';
		    break;
		}
	    }else if(y>=0x4F)
		if(y<=0x58){
		    c=y-0x4F+'0';
		    break;
		}
	default:
	    return 0;
    }
    putchar(c);
    return 1;
}

static int ibm(int x,int y)
{
    char*s;

    if(x!=0xFA)
	return 0;

    switch(y){
	case 0x40: s="i";    break;   case 0x4A: s="I";	   break;
	case 0x41: s="ii";   break;   case 0x4B: s="II";   break;
	case 0x42: s="iii";  break;   case 0x4C: s="III";  break;
	case 0x43: s="iv";   break;   case 0x4D: s="IV";   break;
	case 0x44: s="v";    break;   case 0x4E: s="V";	   break;
	case 0x45: s="vi";   break;   case 0x4F: s="VI";   break;
	case 0x46: s="vii";  break;   case 0x50: s="VII";  break;
	case 0x47: s="viii"; break;   case 0x51: s="VIII"; break;
	case 0x48: s="ix";   break;   case 0x52: s="IX";   break;
	case 0x49: s="x";    break;   case 0x53: s="X";	   break;
	case 0x54: s="";   break;   case 0x58: s="()"; break;
	case 0x55: s="|";    break;   case 0x59: s="No.";  break;
	case 0x56: s="'";    break;   case 0x5A: s="Tel";  break;
	case 0x57: s="\"";   break;   case 0x5B: s="";   break;
	default:   return 0;
    }
    fputs(s,stdout);
    return 1;
}

static int nec(int x,int y)
{
    char*s;

    switch(x){
	case 0x87:
	    if(y<0x40)
		return 0;
	    if(y<=0x53){
		printf("(%i)",y-0x3F);
		return 1;
	    }
	    switch(y){
		case 0x54: s="I";      break;	case 0x59: s="VI";     break;
		case 0x55: s="II";     break;	case 0x5A: s="VII";    break;
		case 0x56: s="III";    break;	case 0x5B: s="VIII";   break;
		case 0x57: s="IV";     break;	case 0x5C: s="IX";     break;
		case 0x58: s="V";      break;	case 0x5D: s="X";      break;
		case 0x5F: s="~";   break;	case 0x60: s="L";   break;
		case 0x61: s="Z`"; break;	case 0x63: s="O"; break;
		case 0x65: s="A["; break;	case 0x64: s="g";   break;
		case 0x6A: s="h";   break;	case 0x68: s="bg"; break;
		case 0x6B: s="Zg"; break;	case 0x6E: s="y[W"; break;
		case 0x70: s="cm";     break;	case 0x6F: s="mm";     break;
		case 0x72: s="mg";     break;	case 0x71: s="km";     break;
		case 0x74: s="cc";     break;	case 0x73: s="kg";     break;
		case 0x80: s="g";     break;	case 0x81: s="h";     break;
		case 0x82: s="No.";    break;	case 0x83: s="K.K.";   break;
		case 0x84: s="TEL";    break;	case 0x88: s="()";   break;
		case 0x85: s="()";   break;	case 0x89: s="(E)";   break;
		case 0x86: s="()";   break;	case 0x8A: s="()";   break;
		case 0x87: s="()";   break;	case 0x8B: s="(L)";   break;
		case 0x8C: s="()";   break;	case 0x8D: s="";   break;
		case 0x8E: s="吳";   break;	case 0x8F: s="a";   break;
		case 0x7E: s="";   break;	case 0x90: s="";     break;
		case 0x91: s="";     break;	case 0x94: s="";     break;
		case 0x92:			case 0x93: s="";     break;
		case 0x95: s="";     break;	case 0x96: s="";     break;
		case 0x97: s="";     break;	case 0x9A: s="";     break;
		case 0x9B: s="";     break;	case 0x9C: s="";     break;
		case 0x62: s="[g";   break;
		case 0x66: s="wN^["; break;
		case 0x67: s="bg";   break;
		case 0x69: s="J[";   break;
		case 0x6C: s="p[Zg"; break;
		case 0x6D: s="~o["; break;
		case 0x75: s=html?"m<sup>2</sup>":"m^2"; break;
		default:   return 0;
	    }
	    break;

	case 0xEF:
	    switch(y){
		case 0xEF: s="i";   break;   case 0xF4: s="vi";	  break;
		case 0xF0: s="ii";  break;   case 0xF5: s="vii";  break;
		case 0xF1: s="iii"; break;   case 0xF6: s="viii"; break;
		case 0xF2: s="iv";  break;   case 0xF7: s="ix";	  break;
		case 0xF3: s="v";   break;   case 0xF8: s="x";	  break;
		case 0xF9: s="";  break;   case 0xFA: s="|";	  break;
		case 0xFB: s="'";   break;   case 0xFC: s="\"";	  break;
		default:   return 0;
	    }
	    break;

	default:
	    return 0;
    }
    fputs(s,stdout);
    return 1;
}

void x0201(int c)
{
    int i;

    switch(c){
	case'': c=0x4A; break;	  case'': c=0x4B; break;
	case'': c=0x62; break;	  case'': c=0x8F; break;
	case'': c=0x84; break;	  case'': c=0x92; break;
	case'': c=0x86; break;	  case'': c=0x93; break;
	case'': fputs("[",stdout); return;
	case'': fputs("u",stdout); return;
	case'': fputs("v",stdout); return;
	case'': fputs("A",stdout); return;
	case'': fputs("B",stdout); return;
	case'': fputs("E",stdout); return;

	case 0xA0:
	case 0xFF:
	    fputs(html?"&nbsp;":" ",stdout);
	    return;

	case'':
	    c=0x94;
	    if((i=getchar())!=''){
		c=0x45;
		ungetc(i,stdin);
	    }
	    break;

	default:
	    if(c>=''){
		if(c<='')
		    c=(c-'')*2+0x40;
		else if(c<='')
		    c=(c-'')*2+0x83;
		else if(c<='')
		    c=(c-'')*2+0x41;
		else if(c<=''){
		    c=(c-'')*2+0x4A+(c>='');
		    if((i=getchar())=='')
			++c;
		    else
			ungetc(i,stdin);
		}else if(c<='')
		    c=c-''+0x69;
		else if(c<=''){
		    c=(c-'')*3+0x6E;
		    switch(i=getchar()){
			case'': ++c;
			case'': ++c;
				 break;

			default: ungetc(i,stdin);
		    }
		}else if(c<='')
		    c=c-''+0x7D+(c>='');
		else if(c<='')
		    c=c-''+0x88;
		else{
		    fputs(bad,stdout);
		    return;
		}
	    }
    }
 /* printf("\x83%c",c); */
    putchar(0x83);
    putchar(c);
}

static int toshiba(int x,int y)
{
    char*s;

    switch(x){
	case 0x81:
	    switch(y){
		case 0xAD: s="()";   break;	case 0xAE: s="(L)";   break;
		case 0xAF: s="I";      break;	case 0xB4: s="VI";     break;
		case 0xB0: s="II";     break;	case 0xB5: s="VII";    break;
		case 0xB1: s="III";    break;	case 0xB6: s="VIII";   break;
		case 0xB2: s="IV";     break;	case 0xB7: s="IX";     break;
		case 0xB3: s="V";      break;	case 0xC0: s="ml";     break;
		case 0xC1: s="mg";     break;	case 0xC2: s="Kg";     break;
		case 0xC3: s="s";    break;	case 0xC4: s="()";   break;
		case 0xC5: s="K.K.";   break;	case 0xC6: s="Tel";    break;
		case 0xC7: s="No.";    break;	case 0xCF: s="A["; break;
		case 0xD1: s="g";   break;	case 0xD0: s="h";   break;
		case 0xD5: s="bg"; break;	case 0xD2: s="L";   break;
		case 0xD9: s="[h"; break;	case 0xD8: s="y[W"; break;
		case 0xEB: s="";     break;	case 0xEC: s="P";     break;
		case 0xF8: s="(CR2)";  break;	case 0xF9: s="()";   break;
		case 0xFA: s="()";   break;	case 0xFB: s="()";   break;
		case 0xEA: s="";     break;
		case 0xD3: s="LO"; break;
		case 0xD4: s="Lbg"; break;
		case 0xD6: s="bg";   break;
		case 0xD7: s="p[Zg"; break;
		default:   return 0;
	    }
	    break;

	case 0x82:
	    switch(y){
		case 0x40:		    case 0x41: s=""; break;
		case 0x42:		    case 0x43: s="d"; break;
		case 0x44: s="E"; break;   case 0x45: s=":";  break;
		case 0x46: s=""; break;
		default:   return 0;
	    }
	    break;

	case 0x83:
	    switch(y){
		case 0xBE: s=""; break;   case 0xDD: s=""; break;
		default:   return 0;
	    }
	    break;

	case 0x84:
	    switch(y){
		case 0xC0: s="";     break;	case 0xC1: s="";    break;
		case 0xC2:			case 0xC3: s=":";     break;
		case 0xDA: s="(IND)";  break;	case 0xDB: s="";    break;
		case 0xDC: s="()"; break;	case 0xDD: s="(DEC)"; break;
		case 0xDE: s="l";      break;	case 0xDF: s="a";    break;
		case 0xE0: s="_";     break;	case 0xE8: s="";    break;
		case 0xE3: s="@";     break;	case 0xE9: s="";    break;
		case 0xE4: s="B";     break;	case 0xEA: s="";    break;
		case 0xE5: s="D";     break;	case 0xEB: s="b";    break;
		case 0xE6: s="F";     break;	case 0xEC: s="";    break;
		case 0xE7: s="H";     break;	case 0xED: s="";    break;
		case 0xEF: s="";     break;	case 0xEE: s="";    break;
		case 0xF0: s="";     break;	case 0xF1: s="";    break;
		case 0xF2: s="";     break;	case 0xF3: s="";    break;
		case 0xF4: s="";     break;	case 0xF5: s="";    break;
		case 0xF6: s="";     break;	case 0xF7: s="";    break;
		case 0xF8: s="";     break;	case 0xF9: s="";    break;
	     /* case 0xFC: s="";     break; */
		default:   return 0;
	    }
	    break;

	case 0x85:
	    if(y>=0x40){
		if(y<=0x7F){
		    x0201(y-0x40+'');
		    return 1;
		}
		if(y>=0x87){
		    if(y<0x90)
			s="";
		    else
			if(y<=0x99){
			    putchar(y-0x90+'0');
			    return 1;
			}
			switch(y){
			    case 0x9A: s="N"; break;
			    case 0x9B: s=""; break;
			    case 0x9C: s=""; break;
			    default:   return 0;
			}
		}else switch(y){
		    case 0x80: s=""; break;	case 0x82: s=""; break;
		    case 0x83: s=""; break;	case 0x84: s="_"; break;
		    case 0x85: s=""; break;	case 0x86: s=""; break;
		    default:   return 0;
		}
		break;
	    }
	default:
	    return 0;
    }
    fputs(s,stdout);
    return 1;
}

static int non0208(int x,int y)
{
    if(range(x,0x81,0xEB)&&range(y,0x40,0xFC)&&y!=0x7F){
	if(x<=0x84){
	    static const char valid[4][24]=
	    {	 /* +0	  +8   +10   +18   +20	 +28   +30   +38 */
		{ 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, /* 8140 */
		  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF8,	 0, 0xFF, /* 8180 */
		     0, 0xFE,	 0, 0x3F, 0xFF, 0x80, 0xFF,  0xF  /* 81C0 */
		},
		{    0,	   1, 0xFF, 0x80, 0xFF, 0xFF, 0xFF, 0xC0, /* 8240 */
		  0x7F, 0xFF, 0xFF, 0xE1, 0xFF, 0xFF, 0xFF, 0xFF, /* 8280 */
		  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC0,    0  /* 82C0 */
		},
		{ 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, /* 8340 */
		  0xFF, 0xFF, 0xFE,    1, 0xFF, 0xFF, 0xFE,    1, /* 8380 */
		  0xFF, 0xFF, 0xFE,    0,    0,	   0,	 0,    0  /* 83C0 */
		},
		{ 0xFF, 0xFF, 0xFF, 0xFF, 0x80,	   0, 0xFF, 0xFE, /* 8440 */
		  0xFF, 0xFF, 0xC0,    1, 0xFF, 0xFF, 0xFF, 0xFE, /* 8480 */
		     0,	   0,	 0,    0,    0,	   0,	 0,    0  /* 84C0 */
		}
	    };
	    if(valid[x-0x81][(y-0x40)/8]&(0x80>>(y&7)))
		return 0;
	}else if(x>=0x88){
	    if(x<0xC0)
		switch(x){
		    case 0x88: if(y>0x9E)
				   return 0;
			       break;

		    case 0x98: if(range(y,0x73,0x9E))
				   break;
		    default:   return 0;
		}
	    else if(x>=0xE0&&(x<0xEA||(x==0xEA&&y<0xA5)))
		return 0;
	}
    }
    fputs(bad,stdout);
    return 1;
}

void help(void)
{
    fprintf(stderr,"%s\nUsage:\tsjisf  [-armhV]\n\n"
		   "\t  W͂̃VtgJISAJIS X 0201̃Ji(ʏ "
		   "pJ^Ji)A\n\tJIS X 0208̃Ji(ʏ SpJ^Ji)ɕ"
		   "AJIS X 0208-1990ɒ`\n\tĂȂR[h"
		   "ef(ʏ Q^)ɒuAWo͂ɃVtgJISœf\n\to"
		   "vO\n\n"
		   "    -i\t͂ꂽAe<fe>fAe&fe&lt;fA"
		   "e&gt;fAe&amp;fɒu\n\t(-iw肳ƁA-mrw"
		   "ꂽ̂Ƃ݂Ȃ܂)\n\n"
		   "    -m\tuHTML^Oe\n\t(-mw肳ƁA-r"
		   "w肳ꂽ̂Ƃ݂Ȃ܂)\n\n"
		   "    -r\t@ˑKȕɒu   : }t"
		   "  (1)A(2)A(3) c\n\n"
		   "    -a\tSp̃At@xbg␔LA\\ȂJIS X"
		   " 0201[}ɒu\n",
	    PGM_NAME);
}

int main(int argc,char**argv)
{
    int i,c;

    while(--argc>0)
	if(*argv[argc]=='-'){
	    char*cp=argv[argc]+1;
	    for(;*cp;++cp)
		switch(*cp){
#if 0
		    case'd': sscanf(cp+1,"%2x%2x",&c,&i);
			     non0208(c,i);
			     return EXIT_SUCCESS;
#endif
		    case'i': input=1;
		    case'm': html=1;
		    case'r': replace=1;
			     break;

		    case'a': z2h=1;
			     break;

		    case'V': fputs(PGM_NAME,stderr);
			     return EXIT_SUCCESS;

		    default: help();
			     return*cp!='h';
		}
	}else{
	    help();
	    return EXIT_FAILURE;
	}

    while((c=getchar())!=EOF)
	if(c<0x80){
	    if(input)
		switch(c){
		    case'&': fputs("&amp;",stdout); continue;
		    case'<': fputs("&lt;", stdout); continue;
		    case'>': fputs("&gt;", stdout); continue;
		}
	    putchar(c);
	}else if(range(c,0x81,0x9F)||range(c,0xE0,0xFC)){
	    i=getchar();
	    if(z2h)
		if(to_ascii(c,i))
		    continue;
	    if(replace){
		if(ibm(c,i))
		    continue;
		if(nec(c,i))
		    continue;
		if(toshiba(c,i))
		    continue;
	    }
	    if(non0208(c,i))
		continue;
	    printf("%c%c",c,i);
	}else
	    x0201(c);

    return EXIT_SUCCESS;
}
